Loading...
Searching...
No Matches
Message Separator
Headers

An empty line separates headers from the message body. More...

## Macros

#define | MSG_SEPARATOR_INIT()
| Initializer for structure msg_separator_t.

## Typedefs

typedef struct msg_separator_s | msg_separator_t
| The structure msg_separator_t contains representation of separator line between message headers and body.

## Enumerations

enum | { msg_separator_hash }

## Functions

msg_separator_t * | msg_separator_init (msg_separator_t x[1])
| Initialize a structure msg_separator_t.
int | msg_is_separator (msg_header_t const *header)
| Test if header object is instance of msg_separator_t.
msg_separator_t * | msg_separator_dup (su_home_t *home, msg_separator_t const *header))
| Duplicate (deep copy) `msg_separator_t`.
msg_separator_t * | msg_separator_copy (su_home_t *home, msg_separator_t const *header))
| Copy a msg_separator_t header structure.
msg_separator_t * | msg_separator_make (su_home_t *home, char const *s)
| Make a header structure msg_separator_t.
msg_separator_t * | msg_separator_format (su_home_t *home, char const *fmt,...)))
| Make a separator line between headers and body from formatting result.

## Variables

msg_parse_f | msg_separator_d
| Parse a separator line between headers and body.
msg_print_f | msg_separator_e
| Print a separator line between headers and body.
msg_hclass_t | msg_separator_class []
| Header class for separator line between headers and body.

## Detailed Description

An empty line separates headers from the message body.

In order to avoid modifying messages with integrity protection, the separator line has its own header structure which is included in the msg_t structure.

## Macro Definition Documentation

## MSG_SEPARATOR_INIT

#define MSG_SEPARATOR_INIT | ( |  | ) |

Initializer for structure msg_separator_t.

A static msg_separator_t structure must be initialized with the MSG_SEPARATOR_INIT() macro. For instance,

msg_separator_t msg_separator = MSG_SEPARATOR_INIT;
MSG_SEPARATOR_INIT
#define MSG_SEPARATOR_INIT()
Initializer for structure msg_separator_t.
Definition msg_protos.h:589
msg_separator_t
struct msg_separator_s msg_separator_t
The structure msg_separator_t contains representation of separator line between message headers and b...
Definition msg_types.h:91

## Typedef Documentation

## msg_separator_t

typedef struct msg_separator_s msg_separator_t

The structure msg_separator_t contains representation of separator line between message headers and body.

The msg_separator_t is defined as follows:

typedef struct msg_separator_s {
msg_common_t sep_common[1]; // Common fragment info
msg_header_t *sep_next; // Pointer to next header
char sep_data[4]; // NUL-terminated separator
} msg_separator_t;
msg_header_t
MSG_HDR_T msg_header_t
Any protocol-specific header object.
Definition msg_types.h:87
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_separator_s
Separator.
Definition msg_types.h:207
msg_separator_s::sep_next
msg_error_t * sep_next
Dummy link to next header.
Definition msg_types.h:209
msg_separator_s::sep_common
msg_common_t sep_common[1]
Common fragment info.
Definition msg_types.h:208
msg_separator_s::sep_data
char sep_data[4]
NUL-terminated separator.
Definition msg_types.h:210

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_separator_hash | Hash of separator line between headers and body.

## Function Documentation

## msg_is_separator()

int msg_is_separator | ( | msg_header_t const * | header | ) |

inline

Test if header object is instance of msg_separator_t.

The function msg_is_separator() returns true (nonzero) if the header class is an instance of separator line between headers and body object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_separator() returns true (nonzero) if the header object is an instance of header separator and false (zero) otherwise.

## msg_separator_copy()

msg_separator_t * msg_separator_copy | ( | su_home_t * | home,
|  | msg_separator_t const * | header )

inline

Copy a msg_separator_t header structure.

The function msg_separator_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  separator = msg_separator_copy(home, msg->msg_separator);
  msg_separator_copy
  msg_separator_t * msg_separator_copy(su_home_t *home, msg_separator_t const *header))
  Copy a msg_separator_t header structure.
  Definition msg_protos.h:720

Returns
  The function msg_separator_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_separator_dup()

msg_separator_t * msg_separator_dup | ( | su_home_t * | home,
|  | msg_separator_t const * | header )

inline

Duplicate (deep copy) `msg_separator_t`.

The function msg_separator_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  separator = msg_separator_dup(home, msg->msg_separator);
  msg_separator_dup
  msg_separator_t * msg_separator_dup(su_home_t *home, msg_separator_t const *header))
  Duplicate (deep copy) msg_separator_t.
  Definition msg_protos.h:674

Returns
  The function msg_separator_dup() returns a pointer to the newly duplicated msg_separator_t header structure, or NULL upon an error.

## msg_separator_format()

msg_separator_t * msg_separator_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a separator line between headers and body from formatting result.

The function msg_separator_format() makes a new separator line between headers and body object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function msg_separator_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_separator_init()

msg_separator_t * msg_separator_init | ( | msg_separator_t | x[1] | ) |

inline

Initialize a structure msg_separator_t.

An msg_separator_t structure can be initialized with the msg_separator_init() function/macro. For instance,

msg_separator_t msg_separator;
msg_separator_init(&msg_separator);
msg_separator_init
msg_separator_t * msg_separator_init(msg_separator_t x[1])
Initialize a structure msg_separator_t.
Definition msg_protos.h:606

Parameters

  x | pointer to msg_separator_t structure

## msg_separator_make()

msg_separator_t * msg_separator_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_separator_t.

The function msg_separator_make() makes a new msg_separator_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling msg_header_make().

Returns
  The function msg_separator_make() returns a pointer to newly maked msg_separator_t header structure, or NULL upon an error.

## Variable Documentation

## msg_separator_class

msg_hclass_t msg_separator_class[]

extern

Header class for separator line between headers and body.

The header class msg_separator_class defines how a separator line between headers and body header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_separator_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.